(*
Copyright 2011 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory List_Order_Implementations
  imports Set_Order_Impl Min_Set_Order_Impl Multiset_Extension_Impl Dual_Multiset_Impl
begin

datatype list_order_type = MS_Ext | Max_Ext | Min_Ext  | Dms_Ext 

fun list_ext :: "nat \<Rightarrow> list_order_type \<Rightarrow> 'a list_ext_impl"
  where "list_ext _ MS_Ext = mul_ext"
     |  "list_ext _ Max_Ext = set_ext"
     |  "list_ext _ Min_Ext = min_set_ext"
     |  "list_ext n Dms_Ext = dms_order_ext n" 

fun list_ext_name :: "list_order_type \<Rightarrow> string"
  where "list_ext_name MS_Ext = ''MS''"
     |  "list_ext_name Dms_Ext = ''DMS''"
     |  "list_ext_name Min_Ext = ''MIN''"
     |  "list_ext_name Max_Ext = ''MAX''"

lemma list_ext: "\<exists> s ns. list_order_extension_impl s ns (list_ext n t)"
proof (cases t)
  case MS_Ext
  thus ?thesis using mul_ext_list_ext by auto
next
  case Max_Ext 
  thus ?thesis using set_ext_list_ext by auto
next
  case Min_Ext 
  thus ?thesis using min_set_ext_list_ext by auto
next
  case Dms_Ext
  thus ?thesis using dms_order_ext_list_ext by auto 
qed
end